#ifndef DESKTOPHEAPINFO_H
#define DESKTOPHEAPINFO_H

#pragma once

#include "stdafx.h"

// who designed the layout of this struct??
typedef struct _DesktopHeapInfo
{
	LONGLONG llHeapDesktop; // 0x0 (pointer to the desktop heap structure as a 64-bit value)
	ULONG dwSessionId; // 0x8 
	// 4 bytes padding x64
	struct tagWINDOWSTATION* pWinSta; // 0xc (x86), 0x10 (x64)
	ULONG dwNumberOfPages; // 0x10 (x86), 0x18 (x64)
	// 4 bytes padding x64
	struct tagDESKTOP* pDesk; // 0x14 (x86), 0x20 (x64)
	ULONG dwNumberOfUncommittedPages; // 0x18 (x86), 0x28 (x64)
	// 4 bytes padding x64
	SIZE_T dwTotalFreeBytes; // 0x1c (x86), 0x30 (x64)
	WCHAR wszWinStaName[0x41]; // 0x20 (x86), 0x38 (x64)
	CHAR padding[6]; // unused, always 0 // 0xa2 (x86), 0xba (x64)
	WCHAR wszDeskName[0x41]; // 0xa8 (x86), 0xc0 (x64)
	// padding to 8 byte boundary // 4 bytes @ 0x12a (x86), 6 bytes @ 0x142 (x64)
} DesktopHeapInfo; // x86 = 0x130, x64 = 0x148

typedef struct _DesktopHeapInfoEntry
{
	SINGLE_LIST_ENTRY nextEntry;
	DesktopHeapInfo dhi;
} DesktopHeapInfoEntry;

#endif
