#ifndef STRUCTS_H
#define STRUCTS_H

#pragma once

#include "stdafx.h"

typedef struct tagWINDOWSTATION
{
	ULONG dwSessionId;
	struct tagWINDOWSTATION* rpWinstaNext;
	struct tagDESKTOP* rpDeskList;
	PVOID pTerm; // struct tagTERMINAL*
	ULONG dwWSF_Flags;
	PVOID spklList; // struct tagKL*
	PVOID ptiClipLock; // struct tagTHREADINFO*
	PVOID ptiDrawingClipboard; // struct tagTHREADINFO*
	PVOID spwndClipOpen; // struct tagWND*
	PVOID spwndClipViewer; // struct tagWND*
	PVOID spwndClipOwner; // struct tagWND*
	PVOID pClipBase; // struct tagCLIP*
	ULONG cNumClipFormats;
	ULONG iClipSerialNumber;
	ULONG iClipSequenceNumber;
	PVOID spwndClipboardListener; // struct tagWND*
	PVOID pGlobalAtomTable; // is actually a PVOID :)
	LUID luidEndSession;
	LUID luidUser;
	struct tagDESKTOP* pDeskCurrent;
} WINDOWSTATION;

// this makes PWINDOWSTATION appear in the symbols
// making debugging a little bit easier
typedef WINDOWSTATION *PWINDOWSTATION;

/*
Win7 RC x86
kd> dt win32k!tagWINDOWSTATION
   +0x000 dwSessionId      : Uint4B
   +0x004 rpwinstaNext     : Ptr32 tagWINDOWSTATION
   +0x008 rpdeskList       : Ptr32 tagDESKTOP
   +0x00c pTerm            : Ptr32 tagTERMINAL
   +0x010 dwWSF_Flags      : Uint4B
   +0x014 spklList         : Ptr32 tagKL
   +0x018 ptiClipLock      : Ptr32 tagTHREADINFO
   +0x01c ptiDrawingClipboard : Ptr32 tagTHREADINFO
   +0x020 spwndClipOpen    : Ptr32 tagWND
   +0x024 spwndClipViewer  : Ptr32 tagWND
   +0x028 spwndClipOwner   : Ptr32 tagWND
   +0x02c pClipBase        : Ptr32 tagCLIP
   +0x030 cNumClipFormats  : Uint4B
   +0x034 iClipSerialNumber : Uint4B
   +0x038 iClipSequenceNumber : Uint4B
   +0x03c spwndClipboardListener : Ptr32 tagWND
   +0x040 pGlobalAtomTable : Ptr32 Void
   +0x044 luidEndSession   : _LUID
   +0x04c luidUser         : _LUID
   +0x054 psidUser         : Ptr32 Void
   +0x058 pdeskCurrent     : Ptr32 tagDESKTOP
*/

struct tagWIN32HEAP;

typedef struct tagDESKTOP
{
	ULONG dwSessionId;
	PVOID pDeskInfo; // struct tagDESKTOPINFO*
	PVOID pDispInfo; // struct tagDISPLAYINFO*
	struct tagDESKTOP* rpDeskNext;
	PWINDOWSTATION rpwinstaParent;
	ULONG dwDTFlags;
	ULONG_PTR dwDesktopId;
	PVOID spmenuSys; // struct tagMENU*
	PVOID spmenuDialogSys; // struct tagMENU*
	PVOID spmenuHScrollSys; // struct tagMENU*
	PVOID spmenuVScrollSys; // struct tagMENU*
	PVOID spwndForeground; // struct tagWND*
	PVOID spwndTray; // struct tagWND*
	PVOID spwndMessage; // struct tagWND*
	PVOID spwndTooltip; // struct tagWND*
	HANDLE hsectionDesktop;
	union
	{
		struct tagWIN32HEAP* pheapDesktop; // use this on win7
		struct _HEAP* pHeap; // this on vista
	};
	ULONG ulHeapSize;
	ULONG cciConsole[2]; // _CONSOLE_CARET_INFO
	LIST_ENTRY PtiList;
	PVOID spwndTrack; // struct tagWND*
	LONG htEx;
	LONG rcMouseHover[4]; // tagRECT
	ULONG dwMouseHoverTime;
	PVOID pMagInputTransform;
} DESKTOP;

typedef DESKTOP *PDESKTOP;

extern "C"
{
	// desktop and winsta types exported by nt
	extern POBJECT_TYPE *ExWindowStationObjectType;
	extern POBJECT_TYPE *ExDesktopObjectType;
}

/*
Win7 RC x86
kd> dt win32k!tagDESKTOP
   +0x000 dwSessionId      : Uint4B
   +0x004 pDeskInfo        : Ptr32 tagDESKTOPINFO
   +0x008 pDispInfo        : Ptr32 tagDISPLAYINFO
   +0x00c rpdeskNext       : Ptr32 tagDESKTOP
   +0x010 rpwinstaParent   : Ptr32 tagWINDOWSTATION
   +0x014 dwDTFlags        : Uint4B
   +0x018 dwDesktopId      : Uint4B
   +0x01c spmenuSys        : Ptr32 tagMENU
   +0x020 spmenuDialogSys  : Ptr32 tagMENU
   +0x024 spmenuHScroll    : Ptr32 tagMENU
   +0x028 spmenuVScroll    : Ptr32 tagMENU
   +0x02c spwndForeground  : Ptr32 tagWND
   +0x030 spwndTray        : Ptr32 tagWND
   +0x034 spwndMessage     : Ptr32 tagWND
   +0x038 spwndTooltip     : Ptr32 tagWND
   +0x03c hsectionDesktop  : Ptr32 Void
   +0x040 pheapDesktop     : Ptr32 tagWIN32HEAP
   +0x044 ulHeapSize       : Uint4B
   +0x048 cciConsole       : _CONSOLE_CARET_INFO
   +0x05c PtiList          : _LIST_ENTRY
   +0x064 spwndTrack       : Ptr32 tagWND
   +0x068 htEx             : Int4B
   +0x06c rcMouseHover     : tagRECT
   +0x07c dwMouseHoverTime : Uint4B
   +0x080 pMagInputTransform : Ptr32 _MAGNIFICATION_INPUT_TRANSFORM
   */

// this isn't the real definition, but it'll do
typedef ULONG_PTR HEAP_ENTRY[2];

static const ULONG g_dwHeapSignature = 0xeeffeeff;

// below definition ok for:
// x86: server 2008 sp1, win7 rtm
// x64: win7 rtm
typedef struct _HEAP
{
	HEAP_ENTRY Entry;
	ULONG SegmentSignature;
	ULONG SegmentFlags;
	LIST_ENTRY SegmentList;
	struct _HEAP* Heap;
	PVOID BaseAddress;
	ULONG NumberOfPages;
	PVOID FirstEntry;
	PVOID LastValidEntry;
	ULONG NumberOfUncommittedPages;
	ULONG NumberOfUncommittedRanges;
	USHORT SegmentAllocatorBackTraceIndex;
	USHORT Reserved;
	LIST_ENTRY UCRSegmentList;
	ULONG Flags;
	ULONG ForceFlags;
	ULONG CompatibilityFlags;
	ULONG EncodeFlagMask;
	HEAP_ENTRY Encoding;
	ULONG_PTR PointerKey;
	ULONG Interceptor;
	ULONG VirtualMemoryThreshold;
	ULONG Signature;
	SIZE_T SegmentReserve;
	SIZE_T SegmentCommit;
	SIZE_T DeCommitFreeBlockThreshold;
	SIZE_T DeCommitTotalFreeThreshold;
	SIZE_T TotalFreeSize;
	// not the full structure
} HEAP;

typedef struct _HEAP* PHEAP;

/*
WinXP layout
kd> dt nt!_HEAP
   +0x000 Entry            : _HEAP_ENTRY
   +0x008 Signature        : Uint4B
   +0x00c Flags            : Uint4B
   +0x010 ForceFlags       : Uint4B
   +0x014 VirtualMemoryThreshold : Uint4B
   +0x018 SegmentReserve   : Uint4B
   +0x01c SegmentCommit    : Uint4B
   +0x020 DeCommitFreeBlockThreshold : Uint4B
   +0x024 DeCommitTotalFreeThreshold : Uint4B
   +0x028 TotalFreeSize    : Uint4B
   +0x02c MaximumAllocationSize : Uint4B
   +0x030 ProcessHeapsListIndex : Uint2B
   +0x032 HeaderValidateLength : Uint2B
   +0x034 HeaderValidateCopy : Ptr32 Void
   +0x038 NextAvailableTagIndex : Uint2B
   +0x03a MaximumTagIndex  : Uint2B
   +0x03c TagEntries       : Ptr32 _HEAP_TAG_ENTRY
   +0x040 UCRSegments      : Ptr32 _HEAP_UCR_SEGMENT
   +0x044 UnusedUnCommittedRanges : Ptr32 _HEAP_UNCOMMMTTED_RANGE
   +0x048 AlignRound       : Uint4B
   +0x04c AlignMask        : Uint4B
   +0x050 VirtualAllocdBlocks : _LIST_ENTRY
   +0x058 Segments         : [64] Ptr32 _HEAP_SEGMENT
   +0x158 u                : __unnamed
   +0x168 u2               : __unnamed
   +0x16a AllocatorBackTraceIndex : Uint2B
   +0x16c NonDedicatedListLength : Uint4B
   +0x170 LargeBlocksIndex : Ptr32 Void
   +0x174 PseudoTagEntries : Ptr32 _HEAP_PSEUDO_TAG_ENTRY
   +0x178 FreeLists        : [128] _LIST_ENTRY
   +0x578 LockVariable     : Ptr32 _HEAP_LOCK
   +0x57c CommitRoutine    : Ptr32     long 
   +0x580 FrontEndHeap     : Ptr32 Void
   +0x584 FrontHeapLockCount : Uint2B
   +0x586 FrontEndHeapType : UChar
   +0x587 LastSegmentIndex : UChar

kd> dt nt!_HEAP_SEGMENT
   +0x000 Entry            : _HEAP_ENTRY
   +0x008 Signature        : Uint4B
   +0x00c Flags            : Uint4B
   +0x010 Heap             : Ptr32 _HEAP
   +0x014 LargestUnCommittedRange : Uint4B
   +0x018 BaseAddress      : Ptr32 Void
   +0x01c NumberOfPages    : Uint4B
   +0x020 FirstEntry       : Ptr32 _HEAP_ENTRY
   +0x024 LastValidEntry   : Ptr32 _HEAP_ENTRY
   +0x028 NumberOfUnCommittedPages : Uint4B
   +0x02c NumberOfUnCommittedRanges : Uint4B
   +0x030 UnCommittedRanges : Ptr32 _HEAP_UNCOMMMTTED_RANGE
   +0x034 AllocatorBackTraceIndex : Uint2B
   +0x036 Reserved         : Uint2B
   +0x038 LastEntryInSegment : Ptr32 _HEAP_ENTRY

Server 2008 rtm
 +0x000 Entry            : _HEAP_ENTRY
   +0x008 SegmentSignature : 0xffeeffee
   +0x00c SegmentFlags     : 1
   +0x010 SegmentListEntry : _LIST_ENTRY [ 0xfe8000a8 - 0xfe8000a8 ]
   +0x018 Heap             : 0xfe800000 _HEAP
   +0x01c BaseAddress      : 0xfe800000 
   +0x020 NumberOfPages    : 0xc00
   +0x024 FirstEntry       : 0xfe800568 _HEAP_ENTRY
   +0x028 LastValidEntry   : 0xff400000 _HEAP_ENTRY
   +0x02c NumberOfUnCommittedPages : 0xbc8
   +0x030 NumberOfUnCommittedRanges : 1
   +0x034 SegmentAllocatorBackTraceIndex : 0
   +0x036 Reserved         : 0
   +0x038 UCRSegmentList   : _LIST_ENTRY [ 0xfe837ff0 - 0xfe837ff0 ]
   +0x040 Flags            : 9
   +0x044 ForceFlags       : 9
   +0x048 CompatibilityFlags : 0
   +0x04c EncodeFlagMask   : 0
   +0x050 Encoding         : _HEAP_ENTRY
   +0x058 PointerKey       : 0
   +0x05c Interceptor      : 0
   +0x060 VirtualMemoryThreshold : 0xfe00
   +0x064 Signature        : 0xeeffeeff
   +0x068 SegmentReserve   : 0x100000
   +0x06c SegmentCommit    : 0x2000
   +0x070 DeCommitFreeBlockThreshold : 0x200
   +0x074 DeCommitTotalFreeThreshold : 0x2000
   +0x078 TotalFreeSize    : 0x118d
   +0x07c MaximumAllocationSize : 0x7ffdefff
   +0x080 ProcessHeapsListIndex : 0
   +0x082 HeaderValidateLength : 0x130
   +0x084 HeaderValidateCopy : (null) 
   +0x088 NextAvailableTagIndex : 0
   +0x08a MaximumTagIndex  : 0
   +0x08c TagEntries       : (null) 
   +0x090 UCRList          : _LIST_ENTRY [ 0xfe837fe8 - 0xfe837fe8 ]
   +0x098 AlignRound       : 0xf
   +0x09c AlignMask        : 0xfffffff8
   +0x0a0 VirtualAllocdBlocks : _LIST_ENTRY [ 0xfe8000a0 - 0xfe8000a0 ]
   +0x0a8 SegmentList      : _LIST_ENTRY [ 0xfe800010 - 0xfe800010 ]
   +0x0b0 AllocatorBackTraceIndex : 0
   +0x0b4 NonDedicatedListLength : 0
   +0x0b8 BlocksIndex      : 0xfe800130 
   +0x0bc UCRIndex         : (null) 
   +0x0c0 PseudoTagEntries : (null) 
   +0x0c4 FreeLists        : _LIST_ENTRY [ 0xfe830aa0 - 0xfe833be8 ]
   +0x0cc LockVariable     : (null) 
   +0x0d0 CommitRoutine    : 0x8ca48ba4     long  win32k!UserCommitDesktopMemory+0
   +0x0d4 FrontEndHeap     : (null) 
   +0x0d8 FrontHeapLockCount : 0
   +0x0da FrontEndHeapType : 0 ''
   +0x0dc Counters         : _HEAP_COUNTERS
   +0x124 TuningParameters : _HEAP_TUNING_PARAMETERS

Win7 Layout
kd> dt nt!_HEAP
   +0x000 Entry            : _HEAP_ENTRY
   +0x008 SegmentSignature : Uint4B
   +0x00c SegmentFlags     : Uint4B
   +0x010 SegmentListEntry : _LIST_ENTRY
   +0x018 Heap             : Ptr32 _HEAP
   +0x01c BaseAddress      : Ptr32 Void
   +0x020 NumberOfPages    : Uint4B
   +0x024 FirstEntry       : Ptr32 _HEAP_ENTRY
   +0x028 LastValidEntry   : Ptr32 _HEAP_ENTRY
   +0x02c NumberOfUnCommittedPages : Uint4B
   +0x030 NumberOfUnCommittedRanges : Uint4B
   +0x034 SegmentAllocatorBackTraceIndex : Uint2B
   +0x036 Reserved         : Uint2B
   +0x038 UCRSegmentList   : _LIST_ENTRY
   +0x040 Flags            : Uint4B
   +0x044 ForceFlags       : Uint4B
   +0x048 CompatibilityFlags : Uint4B
   +0x04c EncodeFlagMask   : Uint4B
   +0x050 Encoding         : _HEAP_ENTRY
   +0x058 PointerKey       : Uint4B
   +0x05c Interceptor      : Uint4B
   +0x060 VirtualMemoryThreshold : Uint4B
   +0x064 Signature        : Uint4B
   +0x068 SegmentReserve   : Uint4B
   +0x06c SegmentCommit    : Uint4B
   +0x070 DeCommitFreeBlockThreshold : Uint4B
   +0x074 DeCommitTotalFreeThreshold : Uint4B
   +0x078 TotalFreeSize    : Uint4B
   +0x07c MaximumAllocationSize : Uint4B
   +0x080 ProcessHeapsListIndex : Uint2B
   +0x082 HeaderValidateLength : Uint2B
   +0x084 HeaderValidateCopy : Ptr32 Void
   +0x088 NextAvailableTagIndex : Uint2B
   +0x08a MaximumTagIndex  : Uint2B
   +0x08c TagEntries       : Ptr32 _HEAP_TAG_ENTRY
   +0x090 UCRList          : _LIST_ENTRY
   +0x098 AlignRound       : Uint4B
   +0x09c AlignMask        : Uint4B
   +0x0a0 VirtualAllocdBlocks : _LIST_ENTRY
   +0x0a8 SegmentList      : _LIST_ENTRY
   +0x0b0 AllocatorBackTraceIndex : Uint2B
   +0x0b4 NonDedicatedListLength : Uint4B
   +0x0b8 BlocksIndex      : Ptr32 Void
   +0x0bc UCRIndex         : Ptr32 Void
   +0x0c0 PseudoTagEntries : Ptr32 _HEAP_PSEUDO_TAG_ENTRY
   +0x0c4 FreeLists        : _LIST_ENTRY
   +0x0cc LockVariable     : Ptr32 _HEAP_LOCK
   +0x0d0 CommitRoutine    : Ptr32     long 
   +0x0d4 FrontEndHeap     : Ptr32 Void
   +0x0d8 FrontHeapLockCount : Uint2B
   +0x0da FrontEndHeapType : UChar
   +0x0dc Counters         : _HEAP_COUNTERS
   +0x130 TuningParameters : _HEAP_TUNING_PARAMETERS
   */

// 0x34 big on x86
typedef struct tagWIN32HEAP
{
	PHEAP Heap; // struct _HEAP*
	ULONG unk1; // usually set to 3, maybe flags of some sort
	char szHeadString[8]; // set to "UH_HEAD"
	char szTailString[8]; // set to "UH_TAIL"
	ULONG cHeapSize;
	ULONG unk2[4];
	LIST_ENTRY unknownLinks;
} WIN32HEAP;

typedef WIN32HEAP *PWIN32HEAP;

#endif
